//-------------------------------------------------------------------------------------------
// Copyright (c) 2008-2010, Institute of Computer Technology, University of Technology Vienna
// Authors:
//   Christoph Grimm, Jan Haase, Markus Damm, Jiong Ou,  
//   Joseph Wenninger, Peter Brunmayr, Muhammad Farooq
// Contact:
//   tuv-ams-lib@ict.tuwien.ac.at
// For the license please read LICENSE.txt
//-------------------------------------------------------------------------------------------

#ifndef AHES_UTILS_DEMANGLE_H_INCLUDED_
#define AHES_UTILS_DEMANGLE_H_INCLUDED_

#include <string>
#include <typeinfo>

namespace TUV_ams_lib {

std::string do_demangle( const char *mangled );

template< typename T >
std::string demangle( T const * const = 0 )
{
  return do_demangle( typeid(T).name() );
}

} // namespace ahes

// include implementation inline, to avoid another library
#include "TUV_ams_lib_demangle.ipp"

#endif // AHES_UTILS_DEMANGLE_INCLUDED_

// kate: space-indent on; indent-width 2; replace-tabs on;
